<?php
/*
Plugin Name: Ultimate Post Type Manager
Plugin URI: http://posttypemanager.wordpress.com/
Description: Manage All your Custom Post Type with ease using this plugin.
Author: XYDAC
Version: 0.1
Author URI: http://xydac.wordpress.com/
License: GPL2
*/
/*  Copyright 2010  deepak.seth  (email : indk@ymail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
define('XYDAC_CPT_NAME',"ultimate-post-type-manager");
define('XYDAC_CPT_VER',"0.1");
define('XYDAC_CPT_PATH',get_bloginfo('wpurl')."/wp-admin/options-general.php?page=".XYDAC_CPT_NAME."&sub=home");


//add_action("init", 'xydac_cpt_scripts');
  //add_action("init", 'xydac_cpt_styles');
add_action( 'admin_menu', 'xydac_cpt_menu');
add_action( 'init', 'xydac_reg_cpt' , 1);
add_action('right_now_content_table_end', 'xydac_right_now');
add_filter( 'pre_get_posts', 'xydac_posts_home' );
//add_action( 'admin_menu', 'xydac_cpt_meta_boxes');
function xydac_cpt_scripts()
{
    wp_register_script('xydac_acc_js', WP_PLUGIN_URL.'/'.XYDAC_CPT_NAME.'/jquery-ui-1.8.5.custom.min.js', array('jquery'));
    wp_enqueue_script('xydac_acc_js'); 

}
function xydac_cpt_styles() { wp_enqueue_style('jquery-ui-1.8.5.custom',WP_PLUGIN_URL.'/'.XYDAC_CPT_NAME.'/jquery-ui-1.8.5.custom.css'); }
function xydac_cpt_menu() {
  $x_men = add_options_page('Post Type Manager', 'Post Type Manager', 'manage_options', XYDAC_CPT_NAME, 'xydac_cpt_menu_manager');
 add_action("admin_print_scripts-$x_men", 'xydac_cpt_scripts');
 //add_action("admin_print_styles-$x_men", 'xydac_cpt_styles');

}
function xydac_cpt_menu_manager() {
	if (!current_user_can('manage_options'))  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
	}
    if(isset($_GET['page']) || isset($_POST['page']))
	if($_GET['page']==XYDAC_CPT_NAME || $_POST['page']==XYDAC_CPT_NAME)
		{
			
            if(isset($_GET['sub']) || isset($_POST['sub']))
            {
                if((isset($_GET['sub']) && $_GET['sub']=='home') || (isset($_POST['sub']) && $_POST['sub']=='home'))
                {
					xydac_cpt_loader();
                }
            }
            else
			{               
                xydac_cpt_loader();
				//home
			}
		}
}
//Returns an array of registered Post types.
function get_reg_cptName(){
	
    $cpts=get_post_types('','objects');
    $a=array();
        foreach ($cpts  as $cpt=>$e ) {array_push($a,$e->name);}
    $cpts = get_option("xydac_cpt");
		if($cpts)
        foreach ($cpts  as $cpt ) {if(!in_array($cpt['name'],$a))  array_push($a,$cpt['name']);}
    return $a;
}
function xydac_cpt_loader()
{
$xydac_edit=array();
$editmode = false;
    //handles create taxonomy
	if(isset($_POST['xydac_create_cpt']))
    {
        if(isset($_POST["xy_post"]['name']) && empty($_POST["xy_post"]['name']))
            $xydac_error= new WP_Error('err', __("Custom Post Type Name is required to create New Custom Post Type"));
        elseif(in_array($_POST["xy_post"]['name'],get_reg_cptName())){
            $xydac_error= new WP_Error('err', __("Custom Post Type already registered !!!"));
        }
        else{
            if(isset($_POST["xy_post"]['name']))
            $_POST["xy_post"]['name'] = sanitize_title_with_dashes($_POST["xy_post"]['name']);
            $xydac_cpts = get_option("xydac_cpt");
            
            if(!$xydac_cpts)
            {
                $temp = array();
                array_push($temp,$_POST["xy_post"]);
                update_option('xydac_cpt',$temp);
            }
            if(is_array($xydac_cpts))
            {

                array_push($xydac_cpts,$_POST["xy_post"]);
                update_option('xydac_cpt',$xydac_cpts);
            }
            $message = __('Custom Post Type Added.');
        $editmode = true;
        }
    }
	//handles update CPT
    if(isset($_POST['xydac_update_cpt']) && $_POST['cpt_name'])
    {
        $editmode = false;
        if(empty($_POST["xy_post"]['name']))
            $xydac_error= new WP_Error('err', __("Custom Post Type Name is required to create New Custom Post Type"));
        elseif($_POST["xy_post"]['name']!=$_POST['cpt_name']){
            $xydac_error= new WP_Error('err', __("Changing Name is not allowed !!!"));
        }
        else{
            $_POST["xy_post"]['name'] = sanitize_title_with_dashes($_POST["xy_post"]['name']);
            $xydac_cpts = get_option("xydac_cpt");
            if(is_array($xydac_cpts))
            {
                foreach($xydac_cpts as $k=>$xydac_cpt)
                     if($xydac_cpt['name']==$_POST['cpt_name'])
                     {unset($xydac_cpts[$k]);break;}
                array_push($xydac_cpts,$_POST["xy_post"]);
                update_option('xydac_cpt',$xydac_cpts);
                $message = __('Custom Post Type Updated.');
            }
        $editmode = true;
        }
    }
	//handles delete taxonomy
    if((isset($_POST['xydac_cpt_doaction_submit']) && isset($_POST['action'])) || (isset($_GET['delete-single']) && isset($_GET['d_name'])))
    { $i=0;
         if((isset($_POST['action']) && $_POST['action']=='delete') || (isset($_GET['delete-single']) && $_GET['delete-single']=='delete'))
         {
            $xydac_cpts = get_option("xydac_cpt");
            if(isset($_POST['delete_cpt']))
            {
                foreach($_POST['delete_cpt'] as $k=>$v)
                {
                    if(is_array($xydac_cpts))
                    {
                        foreach($xydac_cpts as $k=>$xydac_cpt)
                             if($xydac_cpt['name']==$v)
                             {unset($xydac_cpts[$k]);$i=1;}
                    }
                }
            }
            elseif(isset($_GET['d_name']) && !empty($_GET['d_name']))
            {
                foreach($xydac_cpts as $k=>$xydac_cpt)
                         if($xydac_cpt['name']==$_GET['d_name'])
                         {unset($xydac_cpts[$k]);$i=1;}
            }
            if($i)
            {update_option('xydac_cpt',$xydac_cpts);
             $message = __('Custom Post Type Deleted.');}
             else
             {
                 $message = __('Custom Post Type Not Deleted.');}
         }
         $editmode = true;
    }
    if(isset($editmode) && !$editmode)
    {
        if(isset( $_POST["xy_post"]))
            $xydac_edit = $_POST["xy_post"];
    }
    if((isset($_GET['edit-cpt']) && isset($_GET['cptname'])) && !isset($_POST["xy_post"]))
    {
        $xydac_cpts = get_option("xydac_cpt");
        if(is_array($xydac_cpts))
            {
                foreach($xydac_cpts as $xydac_cpt)
                    if(isset($_GET['cptname']))
                    if($xydac_cpt['name']==$_GET['cptname'])
                    {
						
                        $xydac_edit = $xydac_cpt;break;
                    }
            }
    }
    ?>
<div class="wrap" id="page_content">
<h2>Ultimate Post Type Manager</h2>
 <?php
    //xydac_heading("taxonomy");
    if (isset($xydac_error) && is_wp_error($xydac_error) )
        echo "<div class='error below-h2'><p>".$xydac_error->get_error_message()."</p></div>";//updated ?>
    <?php if(isset($message)) { ?>
    <div id="message" class="updated below-h2"><p><?php echo $message; ?></p></div>
    <?php } ?>
  <br class="clear" />
  <div id="col-container">
  <?php
	cpt_col_right();
    if((isset($_GET['edit-cpt']) && isset($_GET['cptname']))&&  (!$editmode))
        cpt_col_left($xydac_edit);
    else
    {
        cpt_col_left();
    }
	__('</div></div>');

}

function cpt_col_left($xydac_edit=false){
$xy_arrs = array(
   'heading-1' => array('arr_label' => 'Labels' , 'name' => 'xydac_acc_label', 'type'=>'heading', 'initialclose'=>false),
'label' =>  array( 'arr_label' => 'Label for Post Type ' , 'name' => 'xy_post[args][label]', 'type'=>'string', 'desc'=>'A plural descriptive name for the post type marked for translation.', 'default'=>' '),
'name' => array( 'arr_label' => 'Name of Post Type' , 'name' => 'xy_post[args][labels][name]', 'type'=>'string', 'desc'=>'general name for the post type, usually plural. The same as, and overridden by Label ', 'default'=>' '),
'singular_name' => array( 'arr_label' => 'Singular Name of Post Type' , 'name' => 'xy_post[args][labels][singular_name]', 'type'=>'string', 'desc'=>'name for one object of this post type. Defaults to value of name ', 'default'=>' '),
'add_new' => array( 'arr_label' => 'Add New Label of Post Type' , 'name' => 'xy_post[args][labels][add_new]', 'type'=>'string', 'desc'=>'the add new text. The default is Add New for both hierarchical and non-hierarchical types.', 'default'=>' '), 
'add_new_item' => array( 'arr_label' => 'Add New Item Label of Post Type' , 'name' => 'xy_post[args][labels][add_new_item]', 'type'=>'string', 'desc'=>'the add new item text. Default is Add New Post/Add New Page', 'default'=>' '), 
'edit_item' => array( 'arr_label' => 'Edit Item Label of Post Type' , 'name' => 'xy_post[args][labels][edit_item]', 'type'=>'string', 'desc'=>'the edit item text. Default is Edit Post/Edit Page', 'default'=>' '),  
'new_item' => array( 'arr_label' => 'New Item Label of Post Type' , 'name' => 'xy_post[args][labels][new_item]', 'type'=>'string', 'desc'=>'the new item text. Default is New Post/New Page', 'default'=>' '),
'view_item' => array( 'arr_label' => 'View Item Label of Post Type' , 'name' => 'xy_post[args][labels][view_item]', 'type'=>'string', 'desc'=>'the view item text. Default is View Post/View Page', 'default'=>' '),
'search_items' => array( 'arr_label' => 'Search Item Label of Post Type' , 'name' => 'xy_post[args][labels][search_item]', 'type'=>'string', 'desc'=>'the search items text. Default is Search Posts/Search Pages', 'default'=>' '),
'not_found' => array( 'arr_label' => 'Not Found Item Label of Post Type' , 'name' => 'xy_post[args][labels][not_found]', 'type'=>'string', 'desc'=>'the not found text. Default is No posts found/No pages found', 'default'=>' '), 
'not_found_in_trash' => array( 'arr_label' => 'Not Found in Thrash Label of Post Type' , 'name' => 'xy_post[args][labels][not_found_in_trash]', 'type'=>'string', 'desc'=>'the not found in trash text. Default is No posts found in Trash/No pages found in Trash', 'default'=>' '),  
'parent_item_colon' => array( 'arr_label' => 'Parent Item with Colon Label of Post Type' , 'name' => 'xy_post[args][labels][parent_item_colon]', 'type'=>'string', 'desc'=>'the parent text. This string isn\'t used on non-hierarchical types. In hierarchical ones the default is Parent Page:', 'default'=>' '),
    'heading-2' => array('arr_label' => 'Options' , 'name' => 'xydac_acc_options', 'type'=>'heading', 'initialclose'=>true),
'public' => array( 'arr_label' => 'Public' , 'name' => 'xy_post[args][public]', 'type'=>'boolean', 'desc'=>'Meta argument used to define default values for publicly_queriable, show_ui, show_in_nav_menus and exclude_from_search.', 'default'=>'true'),
'publicly_queryable' => array( 'arr_label' => 'Publicly Queryable' , 'name' => 'xy_post[args][publicly_queryable]', 'type'=>'boolean', 'desc'=>'Whether post_type queries can be performed from the front end. Default: value of public argument', 'default'=>'true'),
'exclude_from_search' => array( 'arr_label' => 'Exclude from search ' , 'name' => 'xy_post[args][exclude_from_search]', 'type'=>'boolean', 'desc'=>'Whether to exclude posts with this post type from search results.', 'default'=>'false'),
'show_ui' => array( 'arr_label' => 'Show UI' , 'name' => 'xy_post[args][show_ui]', 'type'=>'boolean', 'desc'=>'Whether to generate a default UI for managing this post type. Note that _built-in post types, such as post and page, are intentionally set to false.', 'default'=>'true'),
'query_var' => array( 'arr_label' => 'Query Var' , 'name' => 'xy_post[args][query_var]', 'type'=>'boolean', 'desc'=>'Name of the query var to use for this post type.', 'default'=>'true'),
'can_export' => array( 'arr_label' => 'Can Export' , 'name' => 'xy_post[args][can_export]', 'type'=>'boolean', 'desc'=>'Can this post_type be exported.', 'default'=>'true'),
'show_in_nav_menus' => array( 'arr_label' => 'Show in Navigation Menu' , 'name' => 'xy_post[args][show_in_nav_menus]', 'type'=>'boolean', 'desc'=>'Whether post_type is available for selection in navigation menus. Default: value of public argument', 'default'=>'true'),
'hierarchical' => array( 'arr_label' => 'Hierarchical ' , 'name' => 'xy_post[args][hierarchical]', 'type'=>'boolean', 'desc'=>'Whether the post type is hierarchical. Allows Parent to be specified.', 'default'=>'false'),
'menu_position' => array( 'arr_label' => 'Menu Position' , 'name' => 'xy_post[args][menu_position]', 'type'=>'array', 'desc'=>'The position in the menu order the post type should appear.', 'default'=>'5', 'values'=>array('null'=>'Below Comments','5'=>'Below Post','10'=>'Below Media','20'=>'Below Pages','60'=>'Below First Seperator','100'=>'Below Second Seperator')),
    'heading-3' => array('arr_label' => 'Features' , 'name' => 'xydac_acc_features', 'type'=>'heading', 'initialclose'=>true),
'title' => array( 'arr_label' => 'Support for Title' , 'name' => 'xy_post[args][supports][title]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'true'),
'editor' => array( 'arr_label' => 'Support for  Editor' , 'name' => 'xy_post[args][supports][editor]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'true'),
'author' => array( 'arr_label' => 'Support for Author' , 'name' => 'xy_post[args][supports][author]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'thumbnail' => array( 'arr_label' => 'Support for Thumbnail' , 'name' => 'xy_post[args][supports][thumbnail]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'excerpt' => array( 'arr_label' => 'Support for  Excerpt' , 'name' => 'xy_post[args][supports][excerpt]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'trackbacks' => array( 'arr_label' => 'Support for Trackbacks' , 'name' => 'xy_post[args][supports][trackbacks]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'custom-fields' => array( 'arr_label' => 'Support for Custom Fields' , 'name' => 'xy_post[args][supports][custom-fields]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'comments' => array( 'arr_label' => 'Support for Comments' , 'name' => 'xy_post[args][supports][comments]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'revisions' => array( 'arr_label' => 'Support for Revisions' , 'name' => 'xy_post[args][supports][revisions]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
'page-attributes' => array( 'arr_label' => 'Support for Page attributes' , 'name' => 'xy_post[args][supports][page-attributes]', 'type'=>'boolean', 'desc'=>' ', 'default'=>'false'),
    'heading-4' => array('arr_label' => 'Advanced Options' , 'name' => 'xydac_acc_ad_options', 'type'=>'heading', 'initialclose'=>true),
'description' => array( 'arr_label' => 'Description' , 'name' => 'xy_post[args][description]', 'type'=>'string', 'desc'=>'A short descriptive summary of what the post type is.', 'default'=>' '),
'capability_type' => array( 'arr_label' => 'Capability Type' , 'name' => 'xy_post[args][capability_type]', 'type'=>'string', 'desc'=>'The post type to use for checking read, edit, and delete capabilities.', 'default'=>''),
'register_meta_box_cb' => array( 'arr_label' => 'Register Meta Box CB' , 'name' => 'xy_post[args][register_meta_box_cb]', 'type'=>'string', 'desc'=>'Provide a callback function that will be called when setting up the meta boxes for the edit form. Do remove_meta_box() and add_meta_box() calls in the callback.', 'default'=>' '),
'menu_icon' => array( 'arr_label' => 'Menu Icon' , 'name' => 'xy_post[args][menu_icon]', 'type'=>'string', 'desc'=>'The url to the icon to be used for this menu.', 'default'=>' '),
'permalink_epmask' => array( 'arr_label' => 'Permalink_EPMASK' , 'name' => 'xy_post[args][permalink_epmask]', 'type'=>'string', 'desc'=>'The default rewrite endpoint bitmasks.', 'default'=>' '),
'rewrite' => array( 'arr_label' => 'Rewrite' , 'name' => 'xy_post[args][rewrite][val]', 'type'=>'boolean', 'desc'=>'Rewrite permalinks with this format.', 'default'=>'true'),
'slug' => array( 'arr_label' => 'Slug' , 'name' => 'xy_post[args][rewrite][slug]', 'type'=>'string', 'desc'=>'prepend posts with this slug', 'default'=>' '),
'with_front' => array( 'arr_label' => 'With Front' , 'name' => 'xy_post[args][rewrite][with_front]', 'type'=>'boolean', 'desc'=>'allowing permalinks to be prepended with front base', 'default'=>'true'),
    'heading-5' => array('type'=>'heading','initialclose'=>true, 'finalclose'=>true),
);
?>

<div id='col-left'><div class='col-wrap'>
	<div class='form-wrap'>
	<h3><?php _e('Add a New Custom Post Type','xydac'); ?></h3>
	<form <?php if(is_array($xydac_edit)) _e("id='form_edit_cpt'",'xydac');else _e("id='form_create_cpt'",'xydac'); ?> action='<?php _e(XYDAC_CPT_PATH,'xydac'); ?>' method='post'>
	<div class="form-field form-required <?php if(isset($_POST['xydac_create_cpt']) || isset($_POST['xydac_edit_cpt'])) if(isset($_POST["xy_post"]['name']) && empty($_POST["xy_post"]['name'])) _e('form-invalid','xydac');?>"  >
        <label for='xy_post[name]'>The Name of the Custom Post Type</label>
        <input type='text' name='xy_post[name]' class='name' id='xy_post[name]' value="<?php if(is_array($xydac_edit)) _e($xydac_edit['name'],'xydac'); ?>" />
        <p>Custom Post Type Name identifies your Custom Post among others. It is usually all lowercase and contains only letters, numbers, and hyphens.</p>
    </div>
    <div id="accordion" >
    <?php
	foreach ($xy_arrs as $k=>$xy_arr)
	{$atemp = explode('[',substr($xy_arr['name'],6));
    if($xy_arr['type']=='heading'){ if($xy_arr['initialclose']) _e("</div>"); if(!isset($xy_arr['finalclose'])) { ?>
        <h3 style="cursor:pointer;background:#F6F6F6;border:1px solid #DDD;padding:5px"><?php _e($xy_arr['arr_label']); ?></h3><div>
        <?php  } } else {  ?>
	<div class='form-field' id="xydac_panel_<?php _e($xy_arr['name'],'xydac') ?>"  >
    <?php if($xy_arr['type']=='boolean')
	{?><label for='<?php _e($xy_arr['name'],'xydac') ?>' style="display:inline"><?php _e($xy_arr['arr_label'],'xydac') ?></label>
		<select id='<?php _e($xy_arr['name'],'xydac'); ?>' name='<?php _e($xy_arr['name'],'xydac') ?>' class='postform' style="float:right;width:100px;margin-right:5%">
			<option value='true' <?php if($xy_arr['default']=='true' && !is_array($xydac_edit)) {_e(' Selected','xydac');}elseif(is_array($xydac_edit)) { if(count($atemp)==2) {if($xydac_edit[substr($atemp[1],0,-1)]=='true')_e(' Selected','xydac');}elseif(count($atemp)==3) {if($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)]=='true')_e(' Selected','xydac');} elseif(count($atemp)==4) {if($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)][substr($atemp[3],0,-1)]=='true') _e(' Selected','xydac'); }}  ?>>True</option>
			<option value='false' <?php if($xy_arr['default']=='false' && !is_array($xydac_edit)){ _e('Selected','xydac');}elseif(is_array($xydac_edit)) { if(count($atemp)==2) {if($xydac_edit[substr($atemp[1],0,-1)]=='false')_e(' Selected','xydac');}elseif(count($atemp)==3) {if($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)]=='false')_e(' Selected','xydac');} elseif(count($atemp)==4) {if($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)][substr($atemp[3],0,-1)]=='false') _e(' Selected','xydac');} } ?>>False</option>
		</select>
	<?php } elseif($xy_arr['type']=='array') { ?>
        <label for='<?php _e($xy_arr['name'],'xydac') ?>' style="display:inline"><?php _e($xy_arr['arr_label'],'xydac') ?></label>
        <select id='<?php _e($xy_arr['name'],'xydac'); ?>' name='<?php _e($xy_arr['name'],'xydac') ?>' class='postform' style="float:right;width:150px;margin-right:5%">
            <?php  foreach($xy_arr['values'] as $n=>$c) {   ?>
                <option value='<?php _e($n,'xydac'); ?>' <?php if($xy_arr['default']==$n && !is_array($xydac_edit)) {_e(' Selected','xydac');}elseif(is_array($xydac_edit)) { if(count($atemp)==2) {if($xydac_edit[substr($atemp[1],0,-1)]==$n)_e(' Selected','xydac');}elseif(count($atemp)==3) {if($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)]==$n)_e(' Selected','xydac');} elseif(count($atemp)==4) {if($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)][substr($atemp[3],0,-1)]==$n) _e(' Selected','xydac'); }}  ?>><?php _e($c,'xydac') ?></option>
                <?php } ?>
        </select>
	<?php } elseif($xy_arr['type']=='string') { ?><label for='<?php _e($xy_arr['name'],'xydac') ?>'><?php _e($xy_arr['arr_label'],'xydac') ?></label>
		<input type='text' name='<?php _e($xy_arr['name'],'xydac') ?>' class='name' id='<?php _e($xy_arr['name'],'xydac') ?>' value="<?php if(is_array($xydac_edit)) { if(count($atemp)==3) _e($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)],'xydac'); elseif(count($atemp)==4) _e($xydac_edit[substr($atemp[1],0,-1)][substr($atemp[2],0,-1)][substr($atemp[3],0,-1)],'xydac'); } ?>"/>
	<?php } ?>
	<p><?php _e($xy_arr['desc'],'xydac') ?></p>
    </div>
	<?php  } } if(is_array($xydac_edit)) {?>
            <input type="hidden" name="cpt_name" value="<?php if(isset($_GET['cptname'])) _e($_GET['cptname'],'xydac'); ?>">
        <?php } ?>
</div>
    <p class='submit'>
    <input type="submit"  name="<?php if(!is_array($xydac_edit)) _e('xydac_create_cpt','xydac'); else  _e('xydac_update_cpt','xydac'); ?>" class="button-primary" value="<?php if(!is_array($xydac_edit)) _e('Add Custom Post Type','xydac'); else  _e('Update Custom Post Type','xydac'); ?>"></p>

    </form>
	</div>
	</div>
	</div>
	<?php }

function cpt_col_right(){
    ?>
 <div id="col-right">
      <div class="form-wrap">
          <div style="background:#eee;padding:10px;border:1px solid #ddd">
            <table style="border:0px" width="100%">
                <tr>
                    <td width="50%">
                        <table style = "text-align:left;padding-bottom:3px;">

                            <tr>
                               <th scope="row" valign="top"><b>Plugin Version</b></th>
                               <td>&nbsp;<?php _e(XYDAC_CPT_VER,'xydac'); ?></td>
                           </tr>
                            <tr>
                               <th scope="row" valign="top"><b>Author</b></th>
                               <td>&nbsp;<a href="http://xydac.wordpress.com/" style="padding:4px;font-weight:bold;text-decoration:none">XYDAC</a></td>
                           </tr>
                        </table>
                        <a href="http://posttypemanager.wordpress.com/" style="padding:4px;font-weight:bold;text-decoration:none">Plugin URL</a><br/>
                        <a href="http://wordpress.org/tags/ultimate-post-type-manager" style="padding:4px;font-weight:bold;text-decoration:none">Raise a Support Ticket</a><br/>
                        <a href="http://wordpress.org/extend/plugins/ultimate-post-type-manager/" style="padding:4px;font-weight:bold;text-decoration:none">Rate the Plugin on WordPress</a><br/>
                        <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=nikhilseth1989%40gmail%2ecom&item_name=WordPress%20Plugin%20(Ultimate%20Post%20Type%20Manager)&no_shipping=0&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8" style="padding:4px;font-weight:bold;text-decoration:none">Donate for Improvement of Plugin</a>

                    </td>
                    <td width="50%" valign="top">
                        <?php if(!defined('XYDAC_VER')) { ?>
                        <strong>Other Similar Plugin :</strong><br/>
                        <a href="http://wordpress.org/extend/plugins/ultimate-taxonomy-manager/" style="padding:4px;font-weight:bold;text-decoration:none">Ultimate Taxonomy Manager</a><br/>
                        <a href="http://taxonomymanager.wordpress.com/" style="padding:4px;font-weight:bold;text-decoration:none">-Plugin Home Page</a><br/>
                        <a href="http://downloads.wordpress.org/plugin/ultimate-taxonomy-manager.zip" style="padding:4px;font-weight:bold;text-decoration:none">-Download Latest Version Now</a>
                        
                    <?php } else { ?>
                        Thank You For Installing Ultimate Taxonomy Manager also.Support Further Development with you Esteemed Donation<br/><br/>
                        <span style="color:red;background:yellow;padding:4px;font-weight:bold;"><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=nikhilseth1989%40gmail%2ecom&item_name=WordPress%20Plugin%20(Ultimate%20Taxonomy%20Manager)&no_shipping=0&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8">>>&nbsp;Click Here To Donate&nbsp;<<</a></span>
                    <?php } ?>
                    </td>
                </tr>
            </table>
              
          </div>
          <form id="form_edit" action="<?php _e(XYDAC_CPT_PATH,'xydac'); ?>" method="post"  >
          <div class="tablenav">
            <select name="action">
              <option value=""><?php _e('Bulk Actions','xydac'); ?></option>
              <option value="delete"><?php _e('Delete','xydac'); ?></option>
            </select>
            <input type="submit" class="button-secondary action"  id="xydac_cpt_doaction_submit" name="xydac_cpt_doaction_submit" value="Apply"/>
          </div><br class="clear">
          <table class="widefat tag fixed" cellspacing="0">
            <thead class="content-types-list">
              <tr>
                <th style="" class="manage-column column-cb check-column" id="cb" scope="col"><input type="checkbox"></th>
                <th style="" class="manage-column column-name" id="name" scope="col"><?php _e('Name','xydac'); ?></th>
                <th style="" class="manage-column column-fields" id="label" scope="col"><?php _e('Label','xydac'); ?></th>
              </tr>
            </thead>
            <tbody id="the-list">
            <?php
            $xydac_cpts = get_option("xydac_cpt");
			
			if(is_array($xydac_cpts))
                foreach($xydac_cpts as $xydac_cpt)
                { 
                ?>
            <tr id="content-type-<?php _e($xydac_cpt['name'],'xydac'); ?>" class="">
                <th class="check-column" scope="row">
                  <input type="checkbox" value="<?php _e($xydac_cpt['name'],'xydac'); ?>" name="delete_cpt[]"/>
                </th>
                <td class="name column-name">
                  <strong>
                      <a class="row-title" title="Edit &ldquo;<?php _e($xydac_cpt['name'],'xydac'); ?>&rdquo;" href="<?php echo XYDAC_CPT_PATH."&edit-cpt=true&cptname=".$xydac_cpt['name']; ?>"><?php _e($xydac_cpt['name'],'xydac'); ?></a></strong><br />
                    <div class="row-actions">
                    <span class="edit"><a href="<?php echo XYDAC_CPT_PATH."&edit-cpt=true&cptname=".$xydac_cpt['name']; ?>">Edit</a> | </span>
                    <span class="delete"><a href="<?php echo XYDAC_CPT_PATH."&delete-single=delete&d_name=".$xydac_cpt['name']; ?>">Delete</a></span>
                  </div>
                </td>
                
                <td class="categories column-categories">
                    <?php _e($xydac_cpt['args']['label'],'xydac'); ?>
                </td>
            </tr>
           <?php //echo $row->field_name;
            }   ?>
            </tbody>
            <tfoot>
              <tr>
                <th style="" class="manage-column column-cb check-column"  scope="col"><input type="checkbox"></th>
                <th style="" class="manage-column column-name" scope="col"><?php _e('Name','xydac'); ?></th>
                <th style="" class="manage-column column-fields" scope="col"><?php _e('Label','xydac'); ?></th>
                
              </tr>
            </tfoot>
          </table>
        </form>
          <br class="clear">
          <br class="clear">
          <div class="form-wrap">
            

            </div>
      </div>
    </div>
<?php } 
function xydac_checkbool($string)
{
	if($string=='false')
		return false;
	else
		return true;
}
function xydac_reg_cpt(){
    $cpts = get_option("xydac_cpt");
    if (is_array($cpts) && !empty($cpts))
        foreach ($cpts  as $k=>$cpt )
        {
				$xy_cpt['name'] = $cpt['name'];
				$xy_cpt['args']['label'] = !empty($cpt['args']['label']) ? $cpt['args']['label'] : $xy_cpt['name'];
				$xy_cpt['args']['labels']['name'] = !empty($cpt['args']['labels']['name']) ? $cpt['args']['labels']['name'] : __($xy_cpt['args']['label']);
				$xy_cpt['args']['labels']['singular_name'] = !empty($cpt['args']['labels']['singular_name']) ? $cpt['args']['labels']['singular_name'] : __($xy_cpt['args']['labels']['name']);
				$xy_cpt['args']['labels']['add_new'] = !empty($cpt['args']['labels']['add_new']) ? $cpt['args']['labels']['add_new'] : __('Add New');
				$xy_cpt['args']['labels']['add_new_item'] = !empty($cpt['args']['labels']['add_new_item']) ? $cpt['args']['labels']['add_new_item'] : __('Add New '.$xy_cpt['args']['label']);
				$xy_cpt['args']['labels']['edit_item'] = !empty($cpt['args']['labels']['edit_item']) ? $cpt['args']['labels']['edit_item'] : __('Edit '.$xy_cpt['args']['label']);
				$xy_cpt['args']['labels']['new_item'] = !empty($cpt['args']['labels']['new_item']) ? $cpt['args']['labels']['new_item'] : __('New '.$xy_cpt['args']['label']);
				$xy_cpt['args']['labels']['view_item'] = !empty($cpt['args']['labels']['view_item']) ? $cpt['args']['labels']['view_item'] : __('View '.$xy_cpt['args']['label']);
				$xy_cpt['args']['labels']['search_item'] = !empty($cpt['args']['labels']['search_item']) ? $cpt['args']['labels']['search_item'] : __('Search '.$xy_cpt['args']['label']);
				$xy_cpt['args']['labels']['not_found'] = !empty($cpt['args']['labels']['not_found']) ? $cpt['args']['labels']['not_found'] : __('No '.$xy_cpt['args']['label'].' found');
				$xy_cpt['args']['labels']['not_found_in_trash'] = !empty($cpt['args']['labels']['not_found_in_trash']) ? $cpt['args']['labels']['not_found_in_trash'] : __('No '.$xy_cpt['args']['label'].' found in Thrash');
				$xy_cpt['args']['labels']['parent_item_colon'] = !empty($cpt['args']['labels']['parent_item_colon']) ? $cpt['args']['labels']['parent_item_colon'] : __('Parent '.$xy_cpt['args']['label']);
				$xy_cpt['args']['description'] = !empty($cpt['args']['description']) ? $cpt['args']['description'] : '';
			$xy_cpt['args']['public'] = xydac_checkbool($cpt['args']['public']);
			$xy_cpt['args']['publicly_queryable'] = xydac_checkbool($cpt['args']['publicly_queryable']);
			$xy_cpt['args']['exclude_from_search'] = xydac_checkbool($cpt['args']['exclude_from_search']);
			$xy_cpt['args']['show_ui'] = xydac_checkbool($cpt['args']['show_ui']);
				$xy_cpt['args']['capability_type'] =  !empty($cpt['args']['capability_type']) ? $cpt['args']['capability_type'] : 'post';
			$xy_cpt['args']['hierarchical'] = xydac_checkbool($cpt['args']['hierarchical']);
			$xy_cpt['args']['supports'] = array();
			if(xydac_checkbool($cpt['args']['supports']['title'])) array_push($xy_cpt['args']['supports'],'title');
			if(xydac_checkbool($cpt['args']['supports']['editor'])) array_push($xy_cpt['args']['supports'],'editor');
			if(xydac_checkbool($cpt['args']['supports']['author'])) array_push($xy_cpt['args']['supports'],'author');
			if(xydac_checkbool($cpt['args']['supports']['thumbnail'])) array_push($xy_cpt['args']['supports'],'thumbnail');
			if(xydac_checkbool($cpt['args']['supports']['excerpt'])) array_push($xy_cpt['args']['supports'],'excerpt');
			if(xydac_checkbool($cpt['args']['supports']['trackbacks'])) array_push($xy_cpt['args']['supports'],'trackbacks');
			if(xydac_checkbool($cpt['args']['supports']['custom-fields'])) array_push($xy_cpt['args']['supports'],'custom-fields');
			if(xydac_checkbool($cpt['args']['supports']['comments'])) array_push($xy_cpt['args']['supports'],'comments');
			if(xydac_checkbool($cpt['args']['supports']['revisions'])) array_push($xy_cpt['args']['supports'],'revisions');
			if(xydac_checkbool($cpt['args']['supports']['page-attributes'])) array_push($xy_cpt['args']['supports'],'page-attributes');
				$xy_cpt['args']['register_meta_box_cb'] = !empty($cpt['args']['register_meta_box_cb']) ? $cpt['args']['register_meta_box_cb'] : '';
			$xy_cpt['args']['menu_position'] = intval($cpt['args']['menu_position']);
				$xy_cpt['args']['menu_icon'] = !empty($cpt['args']['menu_icon']) ? $cpt['args']['menu_icon'] : null;
				$xy_cpt['args']['permalink_epmask'] = !empty($cpt['args']['permalink_epmask']) ? $cpt['args']['permalink_epmask'] : 'EP_PERMALINK';
			$xy_cpt['args']['rewrite'] = xydac_checkbool($cpt['args']['rewrite']['val']);
			if(xydac_checkbool($cpt['args']['rewrite']['val'])){
				$xy_cpt['args']['rewrite'] =array();
				$xy_cpt['args']['rewrite']['slug'] = !empty($cpt['args']['rewrite']['slug']) ? $cpt['args']['rewrite']['slug'] :$xy_cpt['name'];
				$xy_cpt['args']['rewrite']['with_front'] = xydac_checkbool($cpt['args']['rewrite']['with_front']);
			}
			else
				$xy_cpt['args']['rewrite'] = xydac_checkbool($cpt['args']['rewrite']['val']);
			$xy_cpt['args']['query_var'] = xydac_checkbool($cpt['args']['query_var']);
			$xy_cpt['args']['can_export'] = xydac_checkbool($cpt['args']['can_export']);
			$xy_cpt['args']['show_in_nav_menus'] = xydac_checkbool($cpt['args']['show_in_nav_menus']);
			register_post_type( $xy_cpt['name'], $xy_cpt['args'] );

				
		}
    flush_rewrite_rules();
	}
/*
 * Function for modifying the Right Now box to show stats
 */
function xydac_right_now() {
	$cpts = get_option("xydac_cpt");
    if (is_array($cpts) && !empty($cpts))
        foreach ($cpts  as $cpt )
        {
        $num_posts = wp_count_posts( $cpt['name'] );
        $num = number_format_i18n( $num_posts->publish );
        $text = _n( $cpt['args']['label'], $cpt['args']['label'], intval($num_posts->publish) );
        if ( current_user_can( 'edit_posts' ) ) {
            $num = "<a href='edit.php?post_type=".$cpt['name']."'>$num</a>";
            $text = "<a href='edit.php?post_type=".$cpt['name']."'>$text</a>";
        }
        echo '<td class="first b b-'.$cpt['name'].'">' . $num . '</td>';
        echo '<td class="t '.$cpt['name'].'">' . $text . '</td>';
        echo '</tr>';

	}
}


function xydac_posts_home( $query ) {
    
	if ( is_home() || is_feed() )
		$query->set( 'post_type', get_post_types('','names') );

	return $query;
}
?>